(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/material'), require('@angular/forms'), require('ngx-pagination'), require('@angular/flex-layout')) :
    typeof define === 'function' && define.amd ? define('my-command-library', ['exports', '@angular/core', '@angular/common', '@angular/material', '@angular/forms', 'ngx-pagination', '@angular/flex-layout'], factory) :
    (global = global || self, factory(global['my-command-library'] = {}, global.ng.core, global.ng.common, global.ng.material, global.ng.forms, global.ngxPagination, global.ng['flex-layout']));
}(this, function (exports, core, common, material, forms, ngxPagination, flexLayout) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    var CommandComponent = /** @class */ (function () {
        function CommandComponent() {
            // @Output() command = new EventEmitter<ICommand>();
            this.title = 'List of Commands';
            this.currentPageNumber = 1;
            this.searchTerm = '';
        }
        CommandComponent.prototype.ngOnInit = function () {
        };
        __decorate([
            core.Input(),
            __metadata("design:type", Array)
        ], CommandComponent.prototype, "commands", void 0);
        CommandComponent = __decorate([
            core.Component({
                selector: 'app-command',
                template: "<div class=\"list-page-container\">\n    <div class=\"list-header\">\n        <h2 mat-subheader>{{title}}</h2>\n        <!-- <h2 class=\"mat-display-1\">{{title}}</h2> -->\n    </div>\n    <div class=\"inputcont\">\n        <form class=\"search-form\">\n            <i matPrefix class=\"material-icons\">\n                search\n            </i>\n            <mat-form-field class=\"input-full-width\">\n\n                <input matInput placeholder=\"Search Command\" value=\"\" [(ngModel)]=\"searchTerm\" name=\"name\">\n            </mat-form-field>\n        </form>\n    </div>\n\n    <div fxLayout=\"row wrap\" fxLayout.xs=\"column\">\n        <div *ngFor=\"let command of commands \n    | commandFilter : searchTerm \n    | paginate: { itemsPerPage: 8, currentPage: currentPageNumber }\" fxFlex=\"25\" fxFlex.md=\"33\" fxFlex.sm=\"50\"\n            fxFlex.xs=\"50\" fxLayout=\"column\" style=\"padding: 2%;\">\n            <div>\n                <mat-card class=\"my-card\">\n                    <mat-card-header>\n                        <mat-icon mat-card-avatar *ngIf=\"command.status==='active'\" class=\"active-status\">lens\n                        </mat-icon>\n                        <mat-icon mat-card-avatar *ngIf=\"command.status==='inactive'\" class=\"inactive-status\">lens\n                        </mat-icon>\n                        <mat-card-title class=\"\">{{command.name}}</mat-card-title>\n                        <mat-card-subtitle>{{command.description}}</mat-card-subtitle>\n                    </mat-card-header>\n\n                    <mat-card-content>\n                        <div *ngIf=\"command.parameterList\">\n                            <h3 class=\"mat-h3\">Parameters:</h3>\n                        </div>\n\n                        <p *ngFor=\"let parameter of command.parameterList; let i = index\">{{i+1}}.\n                            {{parameter.parameterName}},\n                            Description:\n                            {{parameter.parameterDesciption}}</p>\n                        <div *ngIf=\"command.tags\">\n                            <h3 class=\"mat-h3\">Tags: <span class=\"mat-body\">{{command.tags}}</span></h3>\n                        </div>\n                        <div *ngIf=\"command.usage\">\n                            <h3 class=\"mat-h3\">Usage: <span class=\"mat-body\">{{command.usage}}</span></h3>\n                        </div>\n                    </mat-card-content>\n                </mat-card>\n            </div>\n        </div>\n    </div>\n\n    <!-- <mat-nav-list class=\"mat-list\">\n        <mat-list-item (click)=\"onSelectCommand(command)\" *ngFor=\"let command of commands | commandFilter : searchTerm | paginate: { itemsPerPage: 3, currentPage: currentPageNumber, totalItems: commands.length }\">\n            <mat-icon mat-list-icon *ngIf=\"command.status==='active'\" class=\"active-status\">lens</mat-icon>\n            <mat-icon mat-list-icon *ngIf=\"command.status==='inactive'\" class=\"inactive-status\">lens</mat-icon>\n            <h4 mat-line>{{command.name}}</h4>\n            <p mat-line> {{command.desc}} </p>\n        </mat-list-item>\n    </mat-nav-list> -->\n\n</div>\n<div class=\"pagination-control\">\n    <pagination-controls (pageChange)=\"currentPageNumber = $event\" responsive=\"true\"></pagination-controls>\n</div>",
                styles: [".inputcont{width:100%;text-align:center;margin:0 auto}.search-form{width:100%;text-align:center}.input-full-width{width:80%;padding-left:5px}.active-status{color:rgba(18,129,3,.54)}.inactive-status{color:rgba(123,128,123,.54)}.mat-list{margin:0 auto;width:80%}pagination-controls{text-align:center;position:relative;bottom:5px;width:100%}.my-card{min-width:250px;height:300px;background-color:#f5f5f5}.example-header-image{background-size:cover}.wrapper1{display:-ms-grid;display:grid;grid-template-columns:repeat(auto-fit,minmax(320px,1fr));grid-column-gap:1em;grid-row-gap:1em;padding:30px 20px}"]
            }),
            __metadata("design:paramtypes", [])
        ], CommandComponent);
        return CommandComponent;
    }());

    var CommandFilterPipe = /** @class */ (function () {
        function CommandFilterPipe() {
        }
        CommandFilterPipe.prototype.transform = function (commands, searchTerm) {
            if (!commands || !searchTerm) {
                return commands;
            }
            return commands.filter(function (command) {
                return command.name.toLowerCase().indexOf(searchTerm.toLowerCase()) !== -1;
            });
        };
        CommandFilterPipe = __decorate([
            core.Pipe({
                name: 'commandFilter'
            })
        ], CommandFilterPipe);
        return CommandFilterPipe;
    }());

    var CommandModule = /** @class */ (function () {
        function CommandModule() {
        }
        CommandModule = __decorate([
            core.NgModule({
                declarations: [CommandComponent, CommandFilterPipe],
                imports: [
                    common.CommonModule,
                    material.MatIconModule,
                    material.MatListModule,
                    material.MatInputModule,
                    forms.FormsModule,
                    ngxPagination.NgxPaginationModule,
                    material.MatCardModule,
                    flexLayout.FlexLayoutModule
                ],
                exports: [
                    CommandComponent
                ]
            })
        ], CommandModule);
        return CommandModule;
    }());

    exports.CommandModule = CommandModule;
    exports.ɵa = CommandComponent;
    exports.ɵb = CommandFilterPipe;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=my-command-library.umd.js.map
